"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const copydir = require('copy-dir');
const replaceInFiles = require('replace-in-files');
const rimraf = require('rimraf');
const doSwap = async (sourcePath, namespace, targetNamespace) => {
    console.log(`Copying from ${sourcePath} to ./tmp and performing namespace swap from ${namespace} to ${targetNamespace}`);
    rimraf.sync('./tmp');
    copydir.sync(sourcePath, './tmp');
    const doReplace = async (replace) => {
        console.log(`replacing ${replace.from} => ${replace.to} across the source-tree`);
        const options = {
            // Multiple files or globs
            files: [
                'tmp/**/*.*',
            ],
            from: new RegExp(replace.from, 'g'),
            to: replace.to,
        };
        await replaceInFiles(options);
    };
    const nsReplacement = targetNamespace === 'c' ? () => '' : `${targetNamespace}__`;
    await doReplace({ from: `${namespace}__`, to: nsReplacement });
    await doReplace({ from: `${namespace}:`, to: `${targetNamespace}:` });
    await doReplace({
        from: `<namespacePrefix>${namespace}</namespacePrefix>`,
        to: `<namespacePrefix>${targetNamespace}</namespacePrefix>`
    });
    await doReplace({ from: `String namespace = '${namespace}'`, to: `String namespace = '${targetNamespace}'` });
    await doReplace({ from: `String nsp = '${namespace}__'`, to: `String nsp = '${targetNamespace}__'` });
    await doReplace({ from: `@Deprecated`, to: () => '' }); //if we're swapping namespace, we aren't in the packaging org
    await doReplace({ from: `@deprecated`, to: () => '' }); //if we're swapping namespace, we aren't in the packaging org
};
exports.doSwap = doSwap;
//# sourceMappingURL=swap.js.map